<template>
  <div>
    <Ariane
      v-if="author"
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />
    <div class="trunk content">
      <Loader :display="isLoading" />
      <AuthorInfo v-if="author" :author="author" />
      <div class="list block">
        <header class="block-header">
          <h2 class="block-title">
            {{ $t('author.authorAlbums') }}.
            <span>{{
              $tc('profile.album', albumCount, { count: albumCount })
            }}</span>
          </h2>
        </header>
        <template v-if="displayedList.length">
          <div class="products-list albums-list products-list--grid trunk">
            <SmallAlbum
              v-for="album of displayedList"
              :key="album.id"
              :album="album"
              :is-subscription="false"
              :for-search="true"
            />
            <EmptyAlbum v-for="empty of emptyAlbums" :key="empty" />
          </div>

          <Loader :display="isLoadingPage" />
          <Pagination
            v-if="albumCount > paginationLimit"
            :current-page="currentPage"
            :total-page="totalPage"
            :items-per-page="paginationLimit"
            @updatePage="updatePage"
          />
        </template>
      </div>
    </div>
  </div>
</template>

<script>
import Ariane from '~/components/ui/Ariane'
import AuthorInfo from '~/components/AuthorInfo'
import SmallAlbum from '~/components/SmallAlbum'
import EmptyAlbum from '~/components/Empty/EmptyAlbum'
import Pagination from '~/components/ui/Pagination'
import Loader from '~/components/ui/Loader'

export default {
  name: 'AuthorPage',
  components: {
    Ariane,
    AuthorInfo,
    SmallAlbum,
    EmptyAlbum,
    Pagination,
    Loader
  },

  async fetch() {
    await this.loadAuthor()
  },

  data() {
    return {
      isLoading: false,
      isLoadingPage: false,

      breadcrumbs: [this.$t('breadcrumb.home')],
      params: ['/' + this.$i18n.locale + '/'],

      author: null,

      currentPage: 1,
      paginationLimit: 18,
      totalPage: undefined,
      displayedList: []
    }
  },
  computed: {
    title() {
      return `${this.author.nickname} - ${this.$t('author.allAuthorAlbums')}`
    },
    albumCount() {
      return this.author ? this.author.albums.count : 0
    },
    emptyAlbums() {
      const array = []

      if (this.displayedList.length) {
        for (let i = this.displayedList.length % 6; i < 6; i++) {
          array.push(i)
        }
      }

      return array
    }
  },

  methods: {
    async loadAuthor() {
      this.isLoading = true
      try {
        const id = this.$api.extractIdFromSlugId(this.$route.params.id).id

        const data = await this.$api.author(id)
        if (!data) return

        this.author = data

        this.breadcrumbs.push(this.author.nickname)
        this.params.push(this.author.url)

        this.totalPage = Math.ceil(
          this.author.albums.count / this.paginationLimit
        )

        this.author.albums.pages = [this.author.albums.albums]
        await this.setDisplayed()
      } finally {
        this.isLoading = false
      }
    },
    async loadPage(page) {
      if (this.author && this.author.albums.count) {
        this.isLoadingPage = true
        try {
          const offset = (page - 1) * this.paginationLimit

          const data = await this.$api.authorAlbums(this.author.id, offset)
          if (!data) return

          this.author.albums.pages[page - 1] = data.albums
        } finally {
          this.isLoadingPage = false
        }
      }
    },
    updatePage(currentPage) {
      this.currentPage = currentPage

      this.setDisplayed()
    },
    async setDisplayed() {
      if (this.author && this.author.albums.count) {
        if (!this.author.albums.pages[this.currentPage - 1])
          await this.loadPage(this.currentPage)

        this.displayedList = this.author.albums.pages[this.currentPage - 1]
      }
    }
  },

  head() {
    return {
      titleTemplate: this.title
    }
  }
}
</script>

<style lang="scss" scoped>
.content {
  margin-top: 100px;
  padding-bottom: 30px;
}

.list {
  margin-top: 30px;
}

.block-title {
  display: block;
  line-height: 1.39;
  float: left;
  margin: 0 0 15px;
  font-family: DINCond-Regular, sans-serif;
  font-size: 2.57143rem;
  font-weight: 400;
  text-transform: uppercase;

  span {
    color: #ff641e;
    text-transform: none;
    display: inline;
  }
}
</style>
